PRO vs_instrument_event, Event
  ;;
  widget_control, Event.Top, get_uval = InstrumentState, /No_Copy
  CASE Event.ID OF
      InstrumentState.InstrumentApply:BEGIN
          Widget_Control, InstrumentState.InstrumentFW, Get_Value = FilterWidth
          Widget_Control, InstrumentState.InstrumentStart, Get_Value = Starthr
          Widget_Control, InstrumentState.InstrumentEnd, Get_Value = Endhr
          Widget_Control, InstrumentState.InstrumentRot, Get_Value = Rot
          Widget_Control, InstrumentState.InstrumentDIT, Get_Value = DitIndex
          Widget_control, InstrumentState.InstrumentOList, Get_Uvalue = ObsTimes
          ObsTimes = ObsTimes < Endhr > StartHr
          DIT = ([0.025, 0.005])[DitIndex]
          Widget_Control, InstrumentState.InstrumentNDIT, Get_Value = ndit
          ndit = float(ndit)
          PseudoEvent = {INSTRUMENT_EVENT, $
                         ID:InstrumentState.InstrumentNotifyID[0], $
                         Top:InstrumentState.InstrumentNotifyID[1], $
                         Handler:0l, $
                         FilterW:FilterWidth, $
                         StartHr:StartHr, $
                         EndHr:EndHr, $
                         Rot:Rot, $
                         DIT:DIT, $
                         NDIT:NDIT, $
                         ObsTimes:ptr_new(ObsTimes) $
                        }
          
          Widget_control, InstrumentState.InstrumentOList, Set_Uvalue = ObsTimes
          IF Widget_Info(InstrumentState.InstrumentNotifyID[0], /Valid_ID) THEN $
            widget_control, InstrumentState.InstrumentNotifyID[0], Send_Event = PseudoEvent
          widget_control, InstrumentState.InstrumentApply, sens = 0
      END
      InstrumentState.InstrumentDismiss:BEGIN
          Widget_Control, Event.Top, /Clear_Events, /Destroy
          return
      END
      InstrumentState.InstrumentItime:BEGIN
          Widget_Control, InstrumentState.InstrumentITIME, get_val = itime
          itime = float(itime)
          Widget_Control, InstrumentState.InstrumentDIT, get_val = dit
          dit = ([0.025, 0.005])[dit]
          Widget_Control, InstrumentState.InstrumentNDIT, set_val = string(itime/dit)
          Widget_Control, InstrumentState.InstrumentApply, sens = 1
      END
      InstrumentState.InstrumentNDIT:BEGIN
          Widget_Control, InstrumentState.InstrumentNDIT, get_val = ndit
          ndit = float(ndit)
          Widget_Control, InstrumentState.InstrumentDIT, get_val = dit
          dit = ([0.025, 0.005])[dit]
          Widget_Control, InstrumentState.InstrumentItime, set_val = string(dit*ndit)
          Widget_Control, InstrumentState.InstrumentApply, sens = 1
      END
       InstrumentState.InstrumentDIT:BEGIN
          Widget_Control, InstrumentState.InstrumentnDIT, get_val = ndit
          ndit = float(ndit)
          Widget_Control, InstrumentState.InstrumentDIT, get_val = dit
          dit = ([0.025, 0.005])[dit]
          Widget_Control, InstrumentState.InstrumentItime, set_val = string(dit*ndit)
          Widget_Control, InstrumentState.InstrumentApply, sens = 1
      END
      InstrumentState.InstrumentOList:BEGIN
          Widget_COntrol, InstrumentState.InstrumentOList, Get_Uvalue = ObsTimes
          ObsTimes = vs_obsselect(ObsTimes)
          IF total(ObsTimes) NE -99 THEN BEGIN 
              Widget_COntrol, InstrumentState.InstrumentOList, Set_Uvalue=ObsTimes
              Widget_Control, InstrumentState.InstrumentApply, sens=1
          ENDIF
      END 
      InstrumentState.InstrumentLimitEnforce:BEGIN
      END 
      ELSE:Widget_Control, InstrumentState.InstrumentApply, sens = 1
  ENDCASE 
  Widget_control, Event.Top, Set_Uval = InstrumentState, /No_Copy
END 

PRO vs_instrument, NotifyID, State
COMMON vs_block
  ;;
IF NOT vs_debug THEN on_error, 2
  IF NOT Xregistered('vs_instrument')  THEN BEGIN 
      ;;
      lab_apply = 'Apply'
      lab_btime = 'Base Integration Time (ms):'
      lab_dismiss = 'Dismiss'
      lab_enf = 'Enforce'
      lab_end = 'End of Observation (Hrs aft. Meridian):'
      lab_filter = 'Filter width (Frac. of Lambda):'
      lab_itime = 'Total Integration Time (s):'
      lab_limit = 'Maximum Zenith Dist.:'
      lab_ndit = 'Number of integrations:'
      lab_obstimes = 'Observation Time List'
      lab_rot = 'Artificial rotation angle on sky (degrees):'
      lab_start = 'Start of Observation (Hrs bef. Meridian):'
      lab_tit = 'VLTISim Instrument Setup'
      ;;
      limits = [45, 60, 70, 80, 90]
      ;;
      Instrument = State.Instrument
      ;;
      ;;
      InstrumentBase = Widget_Base(tit = lab_tit, /col, /BAse_ALign_Right)
      InstrumentFilterBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentFilterLab = Widget_Label(InstrumentFilterBase, val = lab_filter, font = vs_fonts[1])
      InstrumentFilterWidth = CW_Fslider($
                                          InstrumentFilterBase, $
                                          /edit, $
                                          /drag, $
                                          val = State.FilterW, $
                                          max = 1.0)
      InstrumentStartBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentStartLab = Widget_Label(InstrumentStartBase, val = lab_start, font = vs_fonts[1])
      InstrumentStart = CW_Fslider($
                                    InstrumentStartBase, $
                                    /edit, $
                                    /drag, $
                                    val = State.StartHr, $
                                    min = -12.0, $
                                    max = 0.0)
     
      InstrumentEndBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentEndLab = Widget_Label(InstrumentEndBase, val = lab_end, font = vs_fonts[1])
      InstrumentEnd = CW_Fslider($
                                  InstrumentEndBase, $
                                  /edit, $
                                  /drag, $
                                  val = State.EndHr, $
                                  max = 12.0 )
      InstrumentLimitBase =  Widget_Base(InstrumentBase, col = 2, $
                                         /Base_Align_Right)
      InstrumentLimitLabel = Widget_Label(InstrumentLimitBase, $
                                          val=lab_limit, $
                                          font=vs_fonts[1])
      InstrumentLimitCbase = Widget_Base(InstrumentLimitBase, row = 1)
      InstrumentLimitValue = Widget_Droplist(InstrumentLimitCbase, $
                                              val=cleanstring(string(limits)), $
                                              font=vs_fonts[1])
      InstrumentLimitEnforce = Widget_Button(InstrumentLimitCbase, $
                                              val=lab_enf, $
                                              font=vs_fonts[1])
      

      InstrumentRotBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentRotLab = Widget_Label(InstrumentRotBase, val = lab_rot, font = vs_fonts[1])
      InstrumentRot = CW_Fslider(InstrumentRotBase, $
                                 /edit, $
                                 /drag, $
                                 val = State.Rot, $
                                 min = -180., $
                                 max = 180)

      InstrumentTimeBase = Widget_Base(InstrumentBase, /frame, /col, /BASE_ALIGN_RIGHT )
      TBase1 = Widget_Base(InstrumentTimeBase, col = 2)
      InstrumentBtimeLab = Widget_Label(TBase1, val = lab_btime, font = vs_fonts[1])
      InstrumentBtimeBut = cw_bgroup(TBase1, ['25', '5'], $
                                     font = vs_fonts[1], $
                                     /excl, $
                                     col = 2, $
                                    set_val = where([0.025, 0.005] EQ state.DIT))
      TBase2 = Widget_Base(InstrumentTimeBase, col = 2)
      InstrumentNDITLab =  Widget_Label(TBase2, val = lab_ndit, font = vs_fonts[1])
      InstrumentNDIT = Widget_Text(TBase2,$
                             xsize=30, $
                             val=string(state.NDIT), $
                             font=vs_fonts[2], $ 
                             /edit)
       TBase2 = Widget_Base(InstrumentTimeBase, col = 2)
      InstrumentITIMELab =  Widget_Label(TBase2, val = lab_itime, font = vs_fonts[1])
      InstrumentITIME = Widget_Text(TBase2,$
                             xsize=30, $
                             val=string(state.NDIT*state.DIT), $
                             font=vs_fonts[2], $
                             /edit)
      InstrumentObsTimes = Widget_Button(InstrumentTimeBase, $
                                         val = lab_obstimes, $
                                         font = vs_fonts[1], $
                                         uval = *(state.obstimes))
      InstrumentControlBase = Widget_Base(InstrumentBase, col = 2, /Base_Align_Right)
      InstrumentApply = Widget_Button(InstrumentControlBase, val = lab_apply, font = vs_fonts[1])
      Widget_Control, InstrumentApply, sens=0
      InstrumentDismiss = Widget_Button(InstrumentControlBase, val = lab_dismiss, font = vs_fonts[1])
      InstrumentState = {IS, $
                         InstrumentFW:InstrumentFilterWidth, $
                         InstrumentStart:InstrumentStart, $
                         InstrumentEnd:InstrumentEnd, $
                         InstrumentRot:InstrumentRot, $
                         InstrumentDIT:InstrumentBtimeBut, $
                         InstrumentNDIT:InstrumentNDIT, $
                         InstrumentItime:InstrumentItime, $
                         InstrumentApply:InstrumentApply, $
                         InstrumentDismiss:InstrumentDismiss, $
                         InstrumentNotifyID:NotifyID, $
                         InstrumentOList:InstrumentObsTimes, $
                         InstrumentLimitEnforce:InstrumentLimitEnforce, $
                         InstrumentLimitValue: InstrumentLimitValue $
                        }
      
      widget_control, InstrumentBase, set_uval = InstrumentState, /no_copy
      widget_control, InstrumentBase, /realize
      xmanager, 'vs_instrument', InstrumentBase, /no_block, Group_Leader = NotifyID[1]
  ENDIF 
END 
