;; (c) 1999, 2000 M. Feldt <mfeldt@mpia-hd.mpg.de>
PRO vs_midiexport, state
  ;;
  COMMON vs_block
  IF NOT vs_debug THEN on_error, 2
  ;;
  ;; Initialize
  ;;
  FileName = state.ExportFile
  ExpArray = (*state.result).HFV
  NumElements = n_elements((*state.result).Lambda)
  NumFrames = N_Elements(ExpArray[0, 0, 0, *])
  Isize = N_Elements(ExpArray[0, *, 0, 0])
  ListArray = strarr(NumElements)
  FOR i=0, NumElements-1 DO BEGIN
      ListArray[i] = 'Frame: '+string(format='(i2)', i)+' ('+$
        string(format='(f5.1)', (*state.result).Lambda[i]*1e6)+' um)'
      IF (*state.result).Comment[i] NE '' THEN $
        ListArray[i]=ListArray[i]+' -- '+ (*state.result).Comment[i]
  ENDFOR 
  InFileName = state.InFile
  BaseLine = *state.BaseLine
  NumBlines = state.NumBlines
  BaseSelect = *state.BaseSelect
  ;;
  ;; Build GUI
  ;;
  ExportBase = Widget_Base(title='VS ASCII Export', /col)
  ExportFile = Widget_Text(ExportBase, xsize=20, val=FileName, font=vs_fonts[2], /Edit)
  ExportControl = Widget_Base(ExportBase, /row)
  ExportSelect = Widget_Button(ExportControl, val='Pick File', font=vs_fonts[1])
  ExportCancel = Widget_Button(ExportControl, val='Cancel', font=vs_fonts[1])
  ExportOK = Widget_Button(ExportControl, val='Export', font=vs_fonts[1])
  Widget_Control, ExportBase, /realize
  ;;
  ;; Event Loop
  ;;
  Eflag = 0
  WHILE Eflag EQ 0 DO BEGIN
      Event = Widget_Event(ExportBase)
      CASE Event.ID OF
          ExportSelect:BEGIN
              Widget_Control, ExportFile,  get_val=FileName
              Widget_Control, ExportFile, $
                set_value=dialog_pickfile(filter='*.dat', file=FileName[0])
              Widget_Control, ExportFile,  get_val=FileName
          END 
          ExportCancel:Eflag = 1
          ExportOK:BEGIN
              Eflag = 1
              Widget_Control, ExportFile,  get_val=FileName
              state.ExportFile = FileName[0]
              openw, luna, FileName[0], /Get_LUN
              printf, luna, ';========Data output for filename: '+InFileName
              FOR i=0, NumFrames-1 DO BEGIN
                  printf, luna, ';'
                  printf, luna, ';'
                  printf, luna, ';=====Information on: ' +ListArray[i]
                  printf, luna, ';'
                  printf, luna, ';'                  
                  FOR J=0, NumBlines-1 DO BEGIN
                      OutArr = Fltarr(5, Isize)
                      FOR K=0, 4 DO OutArr[K, *] = ExpArray[J, *, K, I] ;resort for output format
                      OutArr[4, *] = OutArr[4, *]*!radeg
                      printf, luna, ';'
                      printf, luna, ';===Baseline: '+string(J, format='(i2.2)')+' '+$
                        vs_telescopes[BaseLine[0, j]]+' -- '+vs_telescopes[BaseLine[1, j]]
                      printf, luna, ';'
                      printf, luna, ';Time (hrs. of Meridian)#Spatial Freq.(arcsec^-1)#Visibility#Visibility Error#Baseline position angle (deg)'
                      printf, luna, OutArr
                  ENDFOR 
              ENDFOR 
              close, luna
              state.ExportFile = FileName
          END 
          ELSE:
      ENDCASE 
  ENDWHILE 
  Widget_Control, ExportBase, /Clear_Events, /Destroy
END 

  
