PRO vs_readascii, FileName, Image, Nx, Ny, Nskip, DELIMITER=Delimiter, COMCHAR=ComChar, MissingValu=MissingValue
;;
COMMON vs_block
;IF NOT vs_debug THEN on_error, 2
;;
;; error handling
;;
ErrNum = 0
IF NOT vs_debug THEN catch, ErrNum
IF ErrNum NE 0 THEN BEGIN 
    vs_info, 'Caught unexpected error: '+!Err_String, 4
    Image = -1
    return
ENDIF 
;;
;; initialization
;;
IF NOT keyword_set(ComChar) THEN ComChar = '!'
IF NOT keyword_set(Delimiter) THEN Delimiter = ' '
IF N_Elements(MissingValue) EQ 0 THEN MissingValue = float('NaN')
Image = Fltarr(Nx, Ny)
;;
;; open file for reading
;;
openr, Funit, FileName, /get
;;
FieldPos = 0l
Line = string('xxxxx')
REPEAT BEGIN 
    ReadF, Funit, Line
    ComPos = StrPos(Line, ComChar)
    IF ComPos NE -1 THEN $
      Line=StrMid(Line, 0, ComPos); trzuncate line to chars before comment sign
    IF StrLen(Line) NE 0 THEN BEGIN ; if not a complete comment line, continue
        Line = StrTrim(StrCompress(Line), 2) ; remove all unnecessary spaces
        Tokens = Str_Sep(Line, Delimiter) ; split line into tokens
        TokenPos = 0
        TokenNum = N_Elements(Tokens)
        
        IF FieldPos LT Nskip THEN BEGIN 
            FieldPos = FieldPos+min([Nskip, TokenNum])
            TokenPos = TokenPos+min([Nskip, TokenNum])
        ENDIF
        IF TokenPos LT TokenNum THEN BEGIN 
            IF FieldPos-Nskip+TokenNum-TokenPos GT Nx*float(Ny) THEN $
              TokenNum=TokenNum-(FieldPos-Nskip+TokenNum-TokenPos-Nx*float(Ny)) ; truncate if image already filled
            Image[FieldPos-Nskip:FieldPos-Nskip+TokenNum-TokenPos-1] = (float(Tokens))[TokenPos:TokenNum-1]
            FieldPos = FieldPos+Tokennum-TokenPos
        ENDIF 
    ENDIF 
ENDREP UNTIL eof(Funit) OR FieldPos GE Nskip+Nx*float(Ny)
IF FieldPos LT Nskip+Nx*float(Ny) THEN $
  vs_info, 'Could not read enough elements, Image truncated!', 4
END 
