FUNCTION vs_crefile
COMMON vs_block

  lab_Create = 'VLTISim MapMaker'
  lab_pick = 'Pick Input File'
  lab_run = 'Run MapMaker'
  lab_can = 'Cancel'
  lab_file = 'MapMaker Input File'
  lab_cre_im = 'Running MapMaker...'
  ;;
  ;;
  CrefileBase = widget_base(title = lab_create, /column)
  CrefileLab = widget_label(CreFileBase, xsize = 200, value = lab_file)
  CrefileFile = widget_text(CrefileBase, /editable, xsize = 32, ysize = 1, font=vs_fonts[2])
  CrefileButtons = widget_base(CrefileBase, /row)
  CrefilePick = widget_button(CrefileButtons, value = lab_pick, font=vs_fonts[1])
  CrefileRun = widget_button(CrefileButtons, value = lab_run, font=vs_fonts[1])
  CrefileCancel = widget_button(CrefileButtons, value = lab_can, font=vs_fonts[1])
  ;;          
  widget_control, CrefileRun, sensitive = 0
  widget_control, CrefileBase, /realize
  ;;
  eflag = 0
  WHILE eflag NE 1 DO BEGIN
      eve = widget_event(CrefileBase)
      CASE  eve.id OF 
          CrefilePick: BEGIN
              widget_control, CrefileFile, set_value = dialog_pickfile(/must)
              Widget_Control, CrefileRun, sens = 1
          END
          CrefileRun: BEGIN
              widget_control, CrefileFile, get_value = file_com
              widget_control, CrefileLab, set_value = lab_cre_im
              widget_control, /hourglas
              vs_mapmake, file_com[0], outfile = ofname, infow = w_info_lst
              IF ofname EQ 'errorerrorerror' THEN BEGIN 
                  widget_control, CrefileLab, set_value = lab_file
              ENDIF ELSE  eflag = 1
          END
          CrefileCancel: BEGIN
              widget_control, CrefileFile, get_value = ofname
              eflag = 1
          END
          CrefileFile:BEGIN
              Widget_Control, CrefileRun, sens=1
          END 
      ENDCASE 
  ENDWHILE
  widget_control, CrefileBase, /Clear_Events, /destroy
  return, ofname
END 


PRO vs_target_event, Event
  COMMON VS_BLOCK
  widget_control, Event.Top, get_uval=TargetState, /No_Copy
  CASE Event.ID OF
      TargetState.TargetOld:BEGIN
          filename = dialog_pickfile(/must, filter='*.fits')
          IF FileName NE '' THEN BEGIN
              Widget_Control, TargetState.TargetApply, sens=1
              widget_Control, TargetState.TargetFile, set_val=FileName
          ENDIF 
      END 
      TargetState.TargetNew:BEGIN
          FileName = vs_crefile()
          IF FileName[0] NE '' THEN BEGIN
              TargetState.FileID = FileName[0]
              Widget_Control, TargetState.TargetFile, set_val=TargetState.FileID 
              Widget_Control, TargetState.TargetApply, sens=1
          ENDIF 
      END
      TargetState.TargetImp:BEGIN
          vs_fileimp, {FName:TargetState.TargetFile, Apply:TargetState.TargetApply}
      END 
      TargetState.TargetFile:BEGIN
          Widget_Control, TargetState.TargetApply, sens=1
          ;widget_control, Event.ID, get_val=NewID
          ;TargetState.FileID = NewID[0]
      END 
      TargetState.TargetDec:BEGIN
          Widget_Control, TargetState.TargetApply, sens=1
      END 
      TargetState.TargetApply:BEGIN
          widget_control, TargetState.TargetDec, get_val=ObjDec
          widget_control, TargetState.TargetFile, get_val=FileID
          FileID = FileID[0]
          Head = headfits(FileID)
          extast, Head, Hast, NHPar
          IF NHPar NE -1 THEN BEGIN ; valid astrometry in header, 
                                ;override declination setting
              ObjDec = Hast.CRVal[1]
              Widget_Control, TargetState.TargetDec, set_val=string(ObjDec)
          ENDIF 
          ObjDec = float(ObjDec[0])
          PseudoEvent = {TargetEvent, $
                         ID:TargetState.NotifyID[0], $
                         Top:TargetState.NotifyID[1], $
                         Handler:0l, $
                         FileName:FileID, $
                         ObjDec:ObjDec}
          IF vs_debug THEN help, PseudoEvent, /struct
          IF Widget_Info(TargetState.NotifyID[0], /Valid_ID) THEN $
            widget_control, TargetState.NotifyID[0], Send_Event=PseudoEvent
          widget_control, TargetState.TargetApply, sens=0
      END
      TargetState.TargetDismiss:BEGIN
          Widget_Control, Event.Top, /Clear_Events, /Destroy
          return
      END
  ENDCASE 

  widget_control, Event.Top, set_uval=TargetState, /No_Copy
END 
       

PRO vs_target, NotifyID, state
COMMON vs_block

IF NOT Xregistered('vs_target')  THEN BEGIN 

    lab_tit = 'VLTISim Target Setup'
    lab_file = 'Input File'
    lab_old = 'Pick Existing'
    lab_imp = 'Import...'
    lab_new = 'Create New...'
    lab_dec = 'Target Declination'
    lab_apply = 'Apply'
    lab_dismiss = 'Dismiss'
    FileID = state.InFile
    ;;
    ;;
    TargetBase = Widget_Base(/col, tit = lab_tit)
    TargetFBase = Widget_Base(TargetBase, col=2, tit=lab_file, /frame)
    TargetOld = Widget_Button(TargetFBase, val = lab_old, font=vs_fonts[1])
    TargetNew = Widget_Button(TargetFBase, val = lab_new, font=vs_fonts[1])
    TargetImp = Widget_Button(TargetFBase, val = lab_imp, font=vs_fonts[1])
    TargetFLabel = Widget_Label(TargetFBase, val=lab_file, font=vs_fonts[1])
    TargetFile = Widget_Text(TargetFBase, $
                             xsize=30, $
                             val=FileID, $
                             font=vs_fonts[2], $
                             /edit, $
                             /all_events)
    TargetProp = Widget_Base(TargetBase, /frame, /row)
    TargetDecLab = Widget_Label(TargetProp, val=lab_dec, font=vs_fonts[1])
    TargetDec = Widget_Text(TargetProp, $
                            xsize=30, $
                            val=string(format='(f7.2)', state.ObjDec), $
                            font=vs_fonts[2], $
                            /edit, $
                            /all_events)
    TargetControl = Widget_Base(TargetBase, /row, /frame)
    TargetApply = Widget_Button(TargetControl, val = lab_apply, font=vs_fonts[1])
    TargetDismiss = Widget_Button(TargetControl, val = lab_dismiss, font=vs_fonts[1])
    widget_control, TargetBase, /realize
    TargetState = {TS, $
                   TargetOld:TargetOld, $
                   TargetNew:TargetNew, $
                   TargetImp:TargetImp, $
                   TargetFile:TargetFile, $
                   FileID:FileID, $
                   TargetDec:TargetDec, $
                   TargetApply:TargetApply, $
                   TargetDismiss:TargetDismiss, $
                   NotifyID:NotifyID $
                  }

    Widget_Control, TargetApply, sens = 0
    
  widget_control, TargetBase, set_uval = TargetState, /No_Copy
  xmanager, 'vs_target', TargetBase, /no_block, Group_Leader = NotifyID[1]
ENDIF 
    
END 
